package Ightaria;

import java.awt.*;
import java.lang.Math;

import DrawTexts.*;
import DrawHills.*;
import CalculusAndVectors.*;


public class Scene extends Terrain{


Hill[] hills;

//double hFFx, hFFy;  //Even protected not used
//double hFp;         //Protected used              //Rotation of hill.

//double oFp;         //Protected used              //Rotation of observer.
//static double oFFMx, oFFMy;     //Protected used  //Belongs to path, so common to all Hills.
//static double oFFz;             //Protected used  //Belongs to path.


public Scene() {
       super();
}

public Scene( SPad sp,
              SPad spOwn,
              int ScreenXL,    
              int ScreenYL,
              int center_x,
              int center_y,
              int funN, 
              boolean addFunctionToTerrainFunction
   ) {

        super( 
          sp,
          spOwn,
          ScreenXL,    
          ScreenYL,
          center_x,
          center_y,
          funN,
          addFunctionToTerrainFunction
       );
} //Constructor end.


public void paintHill(int obsZ, 
                       int ExternalFrameNumber, 
                       boolean fillScrBackgroundBeforeDraw, 
                       boolean dispalyMoon,
                       boolean displayAxes,
                       double oAltitudeViewAngle
                       ) {

       if( ExternalFrameNumber > -1 ) frameNumber = ExternalFrameNumber;
       oFFz             = obsZ;       //Main place to set.
       this.obsZ        = (int) oFFz; 
       this.hills       = Pop.hills;
       this.displayAxes = displayAxes;

       g.setColor(BackgroundColor);
       if( fillScrBackgroundBeforeDraw ) {
           g.fillRect(0,0,ScreenXL,ScreenYL);
       }

       //ms("PaintScene Member=" + iXinHillsFamily + " FunN=" + funN );     

       this.oAltitudeViewAngle = oAltitudeViewAngle;
       altitudeCos      = (int) (RotationModula * Math.cos(oAltitudeViewAngle));
       altitudeSin      = (int) (RotationModula * Math.sin(oAltitudeViewAngle));

       CosRotationAngle = (int) ( RotationModula * Math.cos( oFp) );
       SinRotationAngle = (int) ( RotationModula * Math.sin(-oFp) );

       hOOx = - (int) ( oFFMx * Math.cos( oFp) + oFFMy * Math.sin(oFp));
       hOOy = - (int) ( oFFMx * Math.sin(-oFp) + oFFMy * Math.cos(oFp));
       hOOz = posZ - (int) oFFz;

       for(int i=1; i<Pop.hlL; i++) {
           //do1 always try to display as far star:
           if( Pop.hills[i].drawAsCloseOrFarStar != Hill.DRAW_AS_NOT_STAR ) Pop.hills[i].paintHillAsStar(ExternalFrameNumber);
           Pop.hills[i].painted = false;  //For all hills:
       }

       //************************************************
       // Do a Terrain 
       //================================================

          PositionMoon();
          if( dispalyMoon ) {
               //Moon behind the hill. 
              if(REventY>0) DisplayMoon();
          }
          ConstructHill(); //This PaintFunction(true); will be
                           //inside of Construct Hills.
    
          if( displayAxes ) {
              //DrawCoordinateAxis();
              //DrawAxisToHill();
          }
          if( dispalyMoon ) {
              //Moon before the hill. 
              if(REventY<0) DisplayMoon(); 
          }
          PaintAuxSigns();

      //================================================
      // Do a Terrain 
      //************************************************
      if(ExternalFrameNumber < 0) frameNumber +=1; 
}



//Must be called only from hills[0]:
public double sceneHeight() {
       //Hills' finiteability/visibility must be already set.
       for(int ih=1; ih<Pop.hlL; ih++) {
            Hill h = hills[ih];
            if( h.visible && (h.drawAsCloseOrFarStar == Hill.DRAW_AS_NOT_STAR ) && 
                (int) h.oDistance < h.YMaxMin ) {

                   //ms(" Ter before paint MeshDrawIx" + firstMeshDrawIx + " " + lastMeshDrawIx);     
                   //sp.wrc ("funN=" + funN + " hOOy=" + hOOy);

                double oHFx =  h.oDistance * Math.sin(h.hFp);
                double oHFy = -h.oDistance * Math.cos(h.hFp);

                return h.Fun( h.funN, (int) oHFx, (int) oHFy );

            }         
       }
       return Terrain( oFFMx, oFFMx ); //do1
}


//Override:
public void InsertSubHill(int iii, int frontDistance) {
       for(int ih=1; ih<Pop.hlL; ih++) {
            Hill h = hills[ih];
            if( h.visible && 
                h.drawAsCloseOrFarStar == Hill.DRAW_AS_NOT_STAR && 
                !h.painted && 
                (int) h.oFrontDistance > frontDistance ) {

                lastMeshDrawIx =iii;
                PaintFunction();  //Draw part of terrain before (Sub)Hill.
                firstMeshDrawIx=iii+1;
                h.paintHill(true, displayAxes, frameNumber,
                            oAltitudeViewAngle);

                //ms(" Ter before paint MeshDrawIx" + firstMeshDrawIx + " " + lastMeshDrawIx);     
                //ms(" Ter after paint MeshDrawIx" + firstMeshDrawIx + " " + lastMeshDrawIx);     
                //sp.wrc ("funN=" + funN + " hOOy=" + hOOy);

            }         
        }
}




}
